.org $0000		; Needed to fool tasm..

.org $0040		; VBlank IRQ
 reti			; Do nothing
.org $0048		; LCDC Status IRQ
 reti			; Do nothing
.org $0050		; Timer Owerflow
 reti 			; Do nothing
.org $0058		; Serial Transfear Completion
 reti			; Do nothing
.org $0060		; Hmm, this is a wierd on
			; Im not sure how this one works
			; Transition from high to low
			; of pin p10-p13
			; I think Its a hardware thing
 reti 			; Do nothing :)
; Irqs done..

.org $0100

; GameBoy Header with correct checksum
.db $00,$C3,$50,$01,$CE,$ED,$66,$66,$CC,$0D,$00,$0B,$03,$73,$00,$83
.db $00,$0C,$00,$0D,$00,$08,$11,$1F,$88,$89,$00,$0E,$DC,$CC,$6E,$E6
.db $DD,$DD,$D9,$99,$BB,$BB,$67,$63,$6E,$0E,$EC,$CC,$DD,$DC,$99,$9F
.db $BB,$B9,$33,$3E	; Standard Nintendo DO NOT CHANGE...

.db "HEROZERO SAMPLE1"	; Cart name   16bytes
.db $00,$00,$00		; Not used
.db $00			; Cart type   ROM Only
.db $00			; ROM Size    32k
.db $00			; RAM Size     0k
.db $de,$ad		; Maker ID    $dead=DiESEL Soft
.db $01			; Version     =1
.db $DA			; Complement check (Important)
.db $ff,$ff		; Cheksum, fix this if you are going to
			; run this in VGB

start			; This is addr $0150
 ld	sp,$fff4	; Put the stack where the GB wants it

 ld	a,%00000000	; No IRQs at all
 ldh	($ff),a

 sub	a		; Misc standard init things..
 ldh	($41),a		; LCDC Status
 ldh	($42),a		; Screen scroll Y=0
 ldh	($43),a		; Screen scroll X=0

 call	waitvbl		; Must be in VBL before turning the screen off.
 ld	a,%00010001	; LCD Controller = Off (No picture on screen)
			; WindowBank = $9800 (Not used)
			; Window = OFF
			; BG Chr = $8000
			; BG Bank= $9800
			; OBJ    = 8x8
			; OBJ    = Off
			; BG     = On
 ldh	($40),a

 call	nor_col		; Normal palette
 call 	move_char	; Move the charset to $8000
 call	move_text	; Move the text to $9800


 call	waitvbl		; Must be in VBL before turning the screen On.
 ld	a,%10010001	; LCD Controller = On
 ldh	($40),a


die          		; Loop and do nothing
 jp	die


waitvbl			; Wait for Vertical blank
 ldh	a,($40)		; LCD screen on??
 add	a,a
 ret	nc
notyet
 ldh	a,($44)		; $ff44=LCDC Y-Pos
 cp	$90		; $90 and bigger = in VBL
 jr	nz,notyet
 ret

white			; All colors to transparent
 ld	a,$00
 ldh	($47),a
 ret

black			; All colors to black
 ld	a,$ff
 ldh	($47),a
 ret

nor_col			; Sets the colors to normal palette
 ld	a,%11100100	; grey 3=11 (Black)
			; grey 2=10 (Dark grey)
			; grey 1=01 (Ligth grey)
			; grey 0=00 (Transparent)
 ldh	($47),a
 ret

move_char
 ld	hl,$8000
 ld	bc,charset
 ld	d,$00		; Like move 256 bytes man
 ld	e,$02		; x2=512

mchar_loop
 ld	a,(bc)
 ld	(hli),a
 inc	bc
 dec	d
 jp	nz,mchar_loop
 dec	e
 jp	nz,mchar_loop
 ret

move_text
 ld	hl,$9800
 ld	bc,the_text
 ld	d,$00
 ld	e,$04		; 256*4=1024=32x32=One whole GB Screen

mtext_loop
 ld	a,(bc)
 and	$3f             ; Lowest 6 bits only
 ld	(hli),a
 inc	bc
 dec	d
 jp	nz,mtext_loop
 dec	e
 jp	nz,mtext_loop
 ret


charset			; Drawn by Berra
#include "gbfont.z80"

the_text
.db		"                    "
.org $+$0c
.db		"HEROZERO OF OLDSKOOL"
.org $+$0c
.db		"     PRESENTS       "
.org $+$0c
.db		"A GAMEBOY           "
.org $+$0c
.db		"DISASSEMBLER FOR DOS"
.org $+$0c
.db		"                    "
.org $+$0c
.db		"THIS IS A SIMPLE    "
.org $+$0c
.db		"SAMPLE JUST TO SHOW "
.org $+$0c
.db 		"HOW TO USE THE      "
.org $+$0c
.db		"SYMBOL SUPPORT      "
.org $+$0c
.db		"                    "
.org $+$0c
.db		"GREETINGS TO        "
.org $+$0c
.db		"RIP MUMBLY GURAN    "
.org $+$0c
.db		"PAN TWK JEFF MARAT  "
.org $+$0c
.db		"LANDY AND AGNEZ     "
.org $+$0c
.db		"                    "
.org $+$0c
.db		"                    "
.org $+$0c
.db		"            HEROZERO"






.block $8000-$		; pad to $8000 with zeros
.end
